<?php

/**
 * pago_egreso_deta actions.
 *
 * @package    controlComisiones
 * @subpackage pago_egreso_deta
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class pago_egreso_detaActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'COM_PAGO_EGRESO',
        'COM_CUENTA_V',
        'COM_RESOLUCION',
        'COM_COMISION',
        'PROYECTOS',
        'COM_TERCERO',
        'TIPOS_COMISION',
        'COM_COMISIONADO',
        'COM_PAGO_APROBADO_V',
        'COM_ESTADO_CUMP',
        'COM_ESTADO_CIERRE'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'COM_CUENTA_V' =>
        array(
            'id_cuenta' => 'COM_PAGO_EGRESO'
        ),
        'COM_RESOLUCION' =>
        array(
            'id_resolucion' => 'COM_CUENTA_V'
        ),
        'COM_COMISION' =>
        array(
            'id_comision' => 'COM_RESOLUCION'
        ),
        'PROYECTOS' =>
        array(
            'id_proyecto-id' => 'COM_COMISION'
        ),
        'TIPOS_COMISION' =>
        array(
            'id_tipo_comision' => 'COM_COMISION'
        ),
        'COM_TERCERO' =>
        array(
            'id_tercero' => 'COM_CUENTA_V'
        ),
        'COM_COMISIONADO' =>
        array(
            'id_tercero' => 'COM_CUENTA_V',
            'id_comision' => 'COM_COMISION'
        ),
        'COM_PAGO_APROBADO_V' =>
        array(
            'id_pago_egreso' => 'COM_PAGO_EGRESO'
        ),
        'COM_ESTADO_CUMP' =>
        array(
            'id_pago_egreso' => 'COM_PAGO_EGRESO'
        ),
        'COM_ESTADO_CIERRE' =>
        array(
            'id_pago_egreso' => 'COM_PAGO_EGRESO'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'COM_PAGO_EGRESO' =>
        array(
            'id_pago_egreso' => 'id_pago_egreso',
            'id_cuenta' => 'id_cuenta',
            'no_pago' => 'no_pago',
            'fecha_pago' => 'fecha_pago',
            'valor_neto' => 'valor_neto',
            'estado' => 'estado',
            'id_anhos' => 'id_anhos',
            'fecha_anulacion' => 'fecha_anulacion',
            'motivo_anulacion' => 'motivo_anulacion',
            'observaciones' => 'observaciones',
            'valor_retencion'=>'valor_retencion'
        ),
        'COM_CUENTA_V' =>
        array(
            'id_resolucion' => 'id_resolucion',
            'no_cuenta' => 'no_cuenta',
            'fecha_cuenta' => 'fecha_cuenta',
            'id_tercero' => 'id_tercero',
            'valor' => 'valor'
        ),
        'COM_RESOLUCION' =>
        array(
            'id_comision' => 'id_comision',
            'no_resolucion' => 'no_resolucion',
            'fecha_resolucion' => 'fecha_resolucion',
            'id_anhos' => 'id_anhos_resol',
            'estado' => 'estado_resol'
        ),
        'COM_COMISION' =>
        array(
            'no_comision' => 'no_comision',
            'fecha_solicitud' => 'fecha_solicitud',
            'id_proyecto' => 'id_proyecto',
            'objeto' => 'objeto',
            'agenda' => 'agenda',
            'fecha_inicio' => 'fecha_inicio_comi',
            'fecha_fin' => 'fecha_fin_comi'
        ),
        'PROYECTOS' =>
        array(
            'descripcion' => 'descripcion_cm',
            'codigo' => 'codigo_cm'
        ),
        'COM_TERCERO' =>
        array(
            'num_doc' => 'num_doc',
            'nombre' => 'nombre'
        ),
        'COM_COMISIONADO' =>
        array(
            'num_dias' => 'num_dias',
            'fecha_salida' => 'fecha_salida',
            'fecha_regreso' => 'fecha_regreso'
        ),
        'COM_PAGO_APROBADO_V' =>
        array(
            'viaticos' => 'viaticos',
            'viaje' => 'viajes'
        ),
        'COM_ESTADO_CUMP' =>
        array(
            'cumplido' => 'cumplido'
        ),
        'COM_ESTADO_CIERRE' =>
        array(
            'cierre' => 'cierre'
        )
    ); //por cada tabla especificar los campos del select
    protected $fields_orderBy = array(
        'id_anhos', 'codigo_cm', 'no_pago', 'fecha_pago'
    ); //campos para el ordenamiento de la consulta
    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'COM_PAGO_EGRESO' =>
        array(
            'id_pago_egreso,a' => array('!=' => array(-1)),
            'id_pago_egreso,b' => array('=' => array('id_pago_egreso')),
            'id_cuenta' => array('=' => array('id_cuenta')),
            'no_pago' => array('=' => array('no_pago')),
            'fecha_pago' => array('BETWEENFECHA' => array('fecha_ini', 'fecha_fin')),
            'estado' => array('=' => array('estado')),
            'id_anhos' => array('=' => array('id_anhos')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        ),
        'COM_CUENTA_V' =>
        array(
            'id_tercero' => array('=' => array('id_tercero')),
        ),
        'COM_RESOLUCION' =>
        array(
            'no_resolucion' => array('=' => array('no_resolucion')),
        ),
        'COM_COMISION' =>
        array(
            'id_proyecto' => array('=' => array('id_proyecto')),
            'no_comision' => array('=' => array('no_comision'))
        ),
        'COM_ESTADO_CUMP' =>
        array(
            'cumplido' => array('=' => array('cumplido')),
        ),
        'COM_ESTADO_CIERRE' =>
        array(
            'cierre' => array('=' => array('cierre')),
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(
    ); // filtros de condicion or
    /*
     * Variable manejo de log
     */
    //true - consulta de menu administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Perfiles';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;


    /*
     * ------------VARIABLES PARA SERVICIO DE SUMATORIA - SUM
     *
     */
    protected $summatory_data = array(
        'COM_PAGO_EGRESO' => array(
            'fields' => array(
                'nvl(valor_neto,0)#valor_neto'
            ),
            'labels' => array('descripcion_cm,Total'),
            'count' => 'id_pago_egreso'
        )
    ); //se especifica por tabla los campos de suma y condiciones de filtro




    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_pago_egreso'; //identificador de la tabla
    protected $id_names = array('id_pago_egreso'); //llave primaria
    protected $field_names = array('id_cuenta', 'no_pago', 'fecha_pago',
        'estado', 'valor_neto', 'id_anhos', 'fecha_anulacion',
        'motivo_anulacion', 'observaciones','valor_retencion'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'COM_PAGO_EGRESO'; //tabla en la cual se aplican los cambios 
    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_pago_egreso'; //identificador unico de la tabla

    protected function postprocessRequest($Action, \sfWebRequest $request, $list_data_post) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);
        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function preprocessRequest($Action, \sfWebRequest $request) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {

            $sql = <<<EOD
select to_char(sysdate,'YYYY') as ID_ANHOS FROM DUAL
EOD;

            $records = CN_TABLE::executeSQL($sql);

            $id_anhos = $records[0]['id_anhos'];
            $id_cuenta = $request['id_cuenta'];

            $request['id_anhos'] = $id_anhos;

            $sql = <<<EOD
select consecutivo from com_consecutivo_pago where id_anhos = $id_anhos
EOD;
            $records = CN_TABLE::executeSQL($sql);

            $consecutivo = $records[0]['consecutivo'];

            $request['no_pago'] = $consecutivo;

            $sql = <<<EOD
update com_consecutivo_pago set consecutivo =($consecutivo+1) where id_anhos = $id_anhos
EOD;

            $request['estado'] = 1;


            CN_TABLE::executeSQL($sql);

            $sql = <<<EOD
select valor from com_cuenta_v where id_cuenta = $id_cuenta
EOD;//*/
            //20170606 se actualizo la consulta para traer tambien las retenciones
            $sql= <<<EOD
            SELECT valor,nvl(valor_imp,0) as valor_imp
FROM com_cuenta_v
JOIN com_resolucion cr
ON cr.id_resolucion=com_cuenta_v.id_resolucion
LEFT JOIN
  (SELECT id_comision,id_tercero,sum(valor_imp) as valor_imp FROM com_comisionado_imp group by id_comision,id_tercero)imp on imp.id_comision=cr.id_comision and imp.id_tercero=com_cuenta_v.ID_TERCERO
WHERE id_cuenta =$id_cuenta
EOD;
            $records = CN_TABLE::executeSQL($sql);

            $valor = $records[0]['valor'];
            $valor_imp=$records[0]['valor_imp'];
            //20170606 el valor del pago de egreso es igual al valor de la cuenta - las retenciones
            $request['valor_neto'] = $valor-$valor_imp;
            $request['valor_retencion'] = $valor_imp;
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function validateAdd(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        $id_cuenta = $request['id_cuenta'];

        $sql = <<<EOD
select count(id_pago_egreso) cantidad from com_pago_egreso where id_cuenta = $id_cuenta and estado = 1
EOD;

        $records = CN_TABLE::executeSQL($sql);

        $cantidad = $records[0]['cantidad'];

        if ($cantidad > 0) {

            $errors['mensaje'] = "Ya existe un pago asociado a esta cuenta. Favor verificar";
            $errors['servicio'] = "pago_egreso";
        }


        /*
         *  Validar la operación, ya sea por SQL
         */


        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateRemove(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateUpdate(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        $id_pago_egreso = $request['id_pago_egreso'];

        $sql = <<<EOD
select count(id_cumplido) cantidad from com_cumplido where id_pago_egreso = $id_pago_egreso
EOD;

        $records = CN_TABLE::executeSQL($sql);

        $cantidad = $records[0]['cantidad'];

        if ($cantidad > 0) {

            $errors['mensaje'] = "Ya se ha registrado cumplido para este pago, no se puede anular.";
            $errors['servicio'] = "cuenta";
        }

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

}
